
#include <stdio.h>
#include <stdlib.h>

#include "config.h"
#include <string.h>
#include "io.h"
#include "unix_defs.h"
#ifdef HAVE_WINDOWS_H
#include <windows.h>
#define sleep(x) Sleep(1000*x)
#else
#include <netinet/in.h>
extern int sleep();
#endif
#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif
#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif

#include "io_interface.h"
#include "io_internal.h"
extern int (*establish_server_connection_ptr)ARGS((IOFile iofile, int do_fallback));

static int
serverAtomicWrite(fd, buffer, length)
void* fd;
void *buffer;
int length;
{
     char *junk_result_str;
     int junk_errno;
     return os_server_write_func(fd, buffer, length, &junk_errno,
				&junk_result_str);
}

static void
usage_exit()
{
    printf("Usage:  format_cmd {checkpoint,restart}\n");
    exit(1);
}

int
main(argc, argv)
int argc;
char **argv;
{
    IOContext context = create_IOcontext(NULL);
    IOFile iofile = (IOFile) context;
    char format_command_char = 'c';
    char format_dump_char = 'D';
    char format_read_char = 'R';
    char format_action_char;

    if (argc == 2) {
	if (strncmp(argv[1], "checkpoint", strlen(argv[1])) == 0) {
	    format_action_char = format_dump_char;
	} else if (strncmp(argv[1], "restart", strlen(argv[1])) == 0) {
	    format_action_char = format_read_char;
	} else {
	    usage_exit();
	}
    } else {
	usage_exit();
    }
    if (establish_server_connection_ptr(iofile, 1) == 0) {
	printf("Failed to contact format server\n");
	return 0;
    }

    if (serverAtomicWrite(iofile->server_fd, &format_command_char, 1) != 1) {
	fprintf(stderr, "command write failed\n");
	exit(1);
    }

    if (serverAtomicWrite(iofile->server_fd, &format_action_char, 1) != 1) {
	fprintf(stderr, "action write failed\n");
	exit(1);
    }

    return 0;
}	
