#ifdef MODULE
#ifndef __KERNEL__
#define __KERNEL__
#endif
#endif

#include <linux/types.h>
#include <linux/fcntl.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/unistd.h>
#include <linux/ctype.h>
#include <linux/fs.h>
#include <asm/uaccess.h>
#include "kpbio.h"
#include "library.h"

#define NAME_SERVER "directory"
#define FILEMAX 2048
#define STRMAX 256
#define INADDRSZ 4

char buffer[FILEMAX];
char buffer2[STRMAX];
char str0[STRMAX];
char str1[STRMAX];
char str2[STRMAX];
char str3[STRMAX];

struct hostent *lookup_name(const char *name)
{
  struct hostent *hp = NULL;
  int fd;
  int ret = 1;
  char *string;
  int i = 0;
  int j = 0;
  int name_found = FALSE;
  char *h_addr_ptrs[8];
  int a,b;
  int len;
  int count;
  int i1, i2, i3, i4;
  unsigned int itotal;
  mm_segment_t fs;

  hp = (struct hostent *)DAllocMM(sizeof(struct hostent));

  down(&kpbio_sem);
  fs = get_fs();
  set_fs(get_ds()); 
  fd = sys_kopen(NAME_SERVER, O_RDONLY, 0); 
  set_fs(fs); 
  if (fd < 0) return NULL;
  fs = get_fs();
  set_fs(get_ds()); 
  ret = sys_kread(fd, (char *) buffer, FILEMAX);    
  sys_close(fd);
  set_fs(fs); 

  while (j < ret) {
    if ((buffer[j] != '\t') && (buffer[j] != '\n')) j++;
    else {
      string  = &buffer[i];
      strncpy(buffer2, string, j-i);
      buffer2[j-i] = '\0';
      if (name_found == TRUE) {
        j = ret + 1;
	a = 0;
	count = 0;
	len = strlen(buffer2);
	for (b = 0; b <= len; b++) {
          if (isdigit(buffer2[b]) == 0) {
	    if (count == 0) {
	      strncpy(str0, &buffer2[a], b-a);
	      str0[b-a] = '\0';
	    }
	    else if (count == 1) {
	      strncpy(str1, &buffer2[a], b-a);
	      str1[b-a] = '\0';
	    }
	    else if (count == 2) {
	      strncpy(str2, &buffer2[a], b-a);
	      str2[b-a] = '\0';
	    }
	    else {
	      strncpy(str3, &buffer2[a], b-a);
	      str3[b-a] = '\0';
	    }
	    a = b+1;
	    count++;
	  }
	}

        i1 = atoi(str0);
        i2 = atoi(str1);
        i3 = atoi(str2);
        i4 = atoi(str3);
        itotal = i1+(i2<<8)+(i3<<16)+(i4<<24);
        h_addr_ptrs[0] = (char *)&itotal;
        break;
      }
      i = j+1;
      j++;
      if (strcmp(name, buffer2) == 0) {
        name_found = TRUE;
      }
    }
  }
  if (name_found == TRUE) {
    hp->h_name = DAllocMM(STRMAX);
    strcpy(hp->h_name, name);   
    hp->h_addrtype = AF_INET;
    hp->h_length = INADDRSZ;
    hp->h_addr_list = h_addr_ptrs;
  }
  else printk("%s not found\n", name);

  up(&kpbio_sem);
  return hp;
}
